//
// Created by robin on 1/8/18.
//

#ifndef QDNSAGG_QDNSQUERY_H
#define QDNSAGG_QDNSQUERY_H

#include <qplatformdefs.h>
#include <QString>
#include "dns-base/QDnsBase.h"

namespace QDns
{
    namespace Base
    {
        class QDnsQuery
        {
        public:
            QDnsQuery();

            QDnsQuery(const QByteArray &packetData, quint32 pos);

            QDnsQuery(const QByteArray &packetData, QDataStream &dataStream);

            virtual ~QDnsQuery() = default;

            QByteArray serialize() const;

            void serialize(QDataStream &dataStream) const;

            bool isValid() const;

            const QString &getName() const;

            void setName(const QString &name);

            RecordType getType() const;

            void setType(RecordType type);

            RecordClass getClass() const;

            void setClass(RecordClass aClass);

        private:
            void parse(const QByteArray &packetData, QDataStream &dataStream);

            bool m_isValid;
            QString m_name;
            quint16 m_type;
            quint16 m_class;
        };
    }
}

#endif //QDNSAGG_QDNSQUERY_H
