//
// Created by robin on 1/12/18.
//

#ifndef QDNSAGG_QDNSRDATAA_H
#define QDNSAGG_QDNSRDATAA_H

#include <qplatformdefs.h>
#include <QByteArray>
#include <QDataStream>
#include <QHostAddress>

#include "QDnsRecordData.h"

namespace QDns
{
    namespace Base
    {
        class QDnsRecordDataA : public QDnsRecordData
        {
        public:
            QDnsRecordDataA();

            QDnsRecordDataA(const QByteArray &packetData, quint32 pos);

            QDnsRecordDataA(const QByteArray &packetData, QDataStream &dataStream);

            QByteArray serialize() const override;

            void serialize(QDataStream &dataStream) const override;

            virtual QDnsRecordData* clone() const override;

            const QHostAddress &getIp() const;

            void setIp(const QHostAddress &ip);

        private:
            void parse(const QByteArray &packetData, QDataStream &dataStream);

            QHostAddress m_ip;
        };
    }
}

#endif //QDNSAGG_QDNSRDATAA_H
