//
// Created by robin on 1/23/18.
//

#ifndef QDNSAGG_QDNSRECORDDATASOA_H
#define QDNSAGG_QDNSRECORDDATASOA_H

#include <qplatformdefs.h>
#include <QByteArray>
#include <QDataStream>
#include <QHostAddress>

#include "QDnsRecordData.h"

namespace QDns
{
    namespace Base
    {
        class QDnsRecordDataSOA : public QDnsRecordData
        {
        public:
            QDnsRecordDataSOA();

            QDnsRecordDataSOA(const QByteArray &packetData, quint32 pos);

            QDnsRecordDataSOA(const QByteArray &packetData, QDataStream &dataStream);

            QByteArray serialize() const override;

            void serialize(QDataStream &dataStream) const override;

            virtual QDnsRecordData* clone() const override;

            const QString &getPrimaryNs() const;

            void setPrimaryNs(const QString &primaryNs);

            const QString &getAdminMb() const;

            void setAdminMb(const QString &adminMb);

            quint32 getSerialNumber() const;

            void setSerialNumber(quint32 serialNumber);

            quint32 getRefreshInterval() const;

            void setRefreshInterval(quint32 refreshInterval);

            quint32 getRetryInterval() const;

            void setRetryInterval(quint32 retryInterval);

            quint32 getExpirationLimit() const;

            void setExpirationLimit(quint32 expirationLimit);

            quint32 getMinimumTtl() const;

            void setMinimumTtl(quint32 minimumTtl);

        private:
            void parse(const QByteArray &packetData, QDataStream &dataStream);

            QString m_primaryNs;

            QString m_adminMb;

            quint32 m_serialNumber;

            quint32 m_refreshInterval;

            quint32 m_retryInterval;

            quint32 m_expirationLimit;

            quint32 m_minimumTtl;
        };
    }
}


#endif //QDNSAGG_QDNSRECORDDATASOA_H
