//
// Created by robin on 1/12/18.
//

#include "dns-base/RecordData/QDnsRecordDataA.h"

namespace QDns
{
    namespace Base
    {
        QDnsRecordDataA::QDnsRecordDataA()
            : QDnsRecordData()
        {
        }

        QDnsRecordDataA::QDnsRecordDataA(const QByteArray &packetData, quint32 pos)
            : QDnsRecordDataA()
        {
            QDataStream dataStream(packetData);
            dataStream.skipRawData(pos);
            parse(packetData, dataStream);
        }

        QDnsRecordDataA::QDnsRecordDataA(const QByteArray &packetData, QDataStream &dataStream)
            : QDnsRecordDataA()
        {
            parse(packetData, dataStream);
        }

        void QDnsRecordDataA::parse(const QByteArray &packetData, QDataStream &dataStream)
        {
            if (dataStream.device()->bytesAvailable() < 4)
            {
                m_isValid = false;
            }
            else
            {
                quint32 ip;
                dataStream >> ip;
                m_ip.setAddress(ip);
            }
        }

        QByteArray QDnsRecordDataA::serialize() const
        {
            QByteArray byteArray;
            QDataStream dataStream(&byteArray, QIODevice::WriteOnly);
            serialize(dataStream);
            return byteArray;
        }

        void QDnsRecordDataA::serialize(QDataStream &dataStream) const
        {
            dataStream << m_ip.toIPv4Address();
        }

        QDnsRecordData *QDnsRecordDataA::clone() const
        {
            auto data = new QDnsRecordDataA();
            data->m_isValid = m_isValid;
            data->m_ip = m_ip;
            return data;
        }

        const QHostAddress &QDnsRecordDataA::getIp() const
        {
            return m_ip;
        }

        void QDnsRecordDataA::setIp(const QHostAddress &ip)
        {
            m_ip = ip;
        }
    }
}